#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

typedef struct {
  int donnee;
  int resultat;
} typSomme;


void *calculSomme(void *arg)
{
  
  if (((typSomme *)arg)->donnee == 1){
    ((typSomme *)arg)->resultat = 1;
  }else{
    typSomme ts;
    pthread_t thread;
    int rc;

    ts.donnee = ((typSomme *)arg)->donnee - 1;
    rc = pthread_create(&thread, NULL, calculSomme, &ts); 
    if (rc){
	perror("pthread_create");
	fprintf(stderr, "((typSomme *)arg)->donnee valait %d\n",
		       ((typSomme *)arg)->donnee);
	exit(EXIT_FAILURE);
    }
    rc = pthread_join(thread, NULL);
    ((typSomme *)arg)->resultat = ((typSomme *)arg)->donnee + ts.resultat;    
  }

  pthread_exit(NULL);
}

int main(int argc, char **argv)
{
  int n;
  typSomme ts; 
  pthread_t thread;
  int rc;
  
  if (argc < 2)
    {
      fprintf(stderr, "Usage: %s entierStrictementPositif\n", argv[0]);
      exit(EXIT_FAILURE);
    }
  
  n = atoi(argv[1]);
  if (n <= 0){
    fprintf(stderr, "Usage: %s entierStrictementPositif\n", argv[0]);
    exit(EXIT_FAILURE);
  }
  
  ts.donnee = n;
  rc = pthread_create(&thread, NULL, calculSomme, &ts); 
  if (rc){
    perror("pthread_create");
    exit(EXIT_FAILURE);
  }
  rc = pthread_join(thread, NULL);

  printf("Somme des %d premiers entiers = %d\n", n, ts.resultat);
  return EXIT_SUCCESS;
}
